#include <OSA.h>


#if   defined(__OSAPICC18__)
    #include <pic18.h>
#elif defined (__OSAPICC16__)
    #include <pic.h>
#elif defined (__OSAPICC12__)
    #include <pic.h>
#endif


//------------------------------------------------------------------------------
#ifdef __OSAMCC18__
#pragma udata access ACCESS
#endif



NEAR OST_SYSTEM_FLAGS   OS_Flags    __osa30_near;   // System state flags

NEAR _OST_INT_TYPE      _OS_temp    __osa30_near;   // For internal purpose
#ifndef __OSAPICC12__
NEAR _OST_INT_TYPE      _OS_tempH   __osa30_near;   // For internal purpose
#endif

OST_TASK_POINTER NEAR _OS_CurTask   __osa30_near;   // Pointer to current task descriptor.

#if !defined(OS_DISABLE_PRIORITY)
    OST_TASK_POINTER OS_BANK _OS_BestTask __osa30_near;   // Pointer to ready task with highest priority (used in OS_Sched)
    OST_TASK_POINTER OS_BANK _OS_LastTask __osa30_near;   // Pointer to last executed task
    OS_BANK _OST_INT_TYPE _OS_best_priority __osa30_near;
#endif

//------------------------------------------------------------------------------

#if OS_TIMERS24 > 0
OS_BANK _OST_INT_TYPE  OS_Ticks    __osa30_near;
#endif

#ifdef OS_ENABLE_DTIMERS
    OS_BANK OST_DTIMER_CB  _OS_DTimers __osa30_near;        // Pointer to list of dynamic timers
    #if defined(__OSAMCC30__)
        OS_BANK OST_DTIMER * _OS_DTimerWork __osa30_near;   // Temp var for work with list of dynamic 
                                                            // timers in ISR
    #endif
#endif

#ifdef __OSAMCC18__
#pragma udata
#endif
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
// Binary semaphores
#if OS_BSEMS > 0
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_bsems
                #endif
            #endif
OS_BSEM_BANK _OST_INT_TYPE OS_BSems[(OS_BSEMS + _OST_INT_SIZE-1) / _OST_INT_SIZE] __osa30_near;
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
// Task descriptors
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_tasks
                #endif
            #endif
OS_TASKS_BANK OST_TCB OS_TaskVars[OS_TASKS] __osa30_near;
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
// Timeouts for old style static timers
#if OS_TIMERS > 0
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timeout
                #endif
            #endif
OS_TIMEOUTS_BANK _OST_INT_TYPE OS_Timeouts[(OS_TIMERS + _OST_INT_SIZE - 1) / _OST_INT_SIZE] __osa30_near;
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
// 32-bit old style static timers
#if OS_TIMERS32 > 0

            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers32
                #endif
            #endif
OS_TIMERS32_BANK __osa_uint32 OS_Timers32[OS_TIMERS32] __osa30_near;
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
// 24-bit old style static timers
#if OS_TIMERS24 > 0
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers24
                #endif
            #endif
OS_TIMERS24_BANK __osa_uint16 OS_Timers24[OS_TIMERS24] __osa30_near;
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
// 16-bit old style static timers
#if OS_TIMERS16 > 0
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers16
                #endif
            #endif
OS_TIMERS16_BANK __osa_uint16 OS_Timers16[OS_TIMERS16] __osa30_near;
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
// 8-bit old style static timers
#if OS_TIMERS8 > 0
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers8
                #endif
            #endif
OS_TIMERS8_BANK __osa_uint8 OS_Timers8[OS_TIMERS8] __osa30_near;
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
// Static timers
#if OS_STIMERS > 0
            #if OS_BANK_STIMERS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_stimers
                #endif
            #endif
OS_STIMERS_BANK _OST_STIMER OS_STimers[OS_STIMERS] __osa30_near;
            #if OS_BANK_STIMERS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif










//------------------------------------------------------------------------------

#if defined(__OSAPICC18__)
    #include <port\osa_picc18.c>         // HT-PICC18
#elif defined(__OSAMCC18__)
    #include <port\osa_mcc18.c>          // MPLAB C18
#elif defined(__OSAMCC30__)
    #include <port\osa_mcc30.c>          // MPLAB C30
#elif defined(__OSAPICC12__)
    #include <port\osa_picc12.c>         // HT_PICC for 12-bit PICs
#elif defined(__OSAPICC__)
    #include <port\osa_picc16.c>         // HT_PICC
//#elif defined(__OSACCS18__)
//    #include <port\osa_ccs18.c>          // CCS-PICC (for PIC18 only)
//    //      , .. PICC   
//    // #locate,     #ifdef'
//    #include "port\osa_ccs18_locate.h"
#else
    #error "Unknown compiler!"
#endif

//------------------------------------------------------------------------------





















/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/


#ifdef OS_ENABLE_CSEM

/************************************************************************/
/* Check counting semaphore                                             */
/************************************************************************/
#if OS_CSEM_SIZE > 1

    bit _OS_CheckCSem(OST_CSEM *pCSem)
    {
        _OS_temp = OS_DI();
        if (*pCSem) _OS_temp |= 1;
        OS_RI(_OS_temp);
        if (_OS_temp & 1) return 1;
        return 0;
    }

#endif


/************************************************************************/
/* Increase counting semaphore. Set EventError if csem is FF...         */
/************************************************************************/
#if !defined(_OS_SignalCSem_DEFINED)

    void _OS_SignalCSem (OST_CSEM *pCSem)
    {
        __OS_CSEM_DI();
        OS_Flags.bEventError = 0;

        (*pCSem)++;
        if (!*pCSem) {
            (*pCSem) = -1;
            OS_Flags.bEventError = 1;
        }
        __OS_CSEM_RI();
    }

#endif  // !defined(_OS_SignalCSem)



#if defined(OS_ENABLE_INT_CSEM) && !defined(_OS_IntSignalCSem_DEFINED)
    void _OS_IntSignalCSem (OST_CSEM *pCSem)
    {
        OS_Flags.bEventError = 0;

        (*pCSem)++;
        if (!*pCSem) {
            (*pCSem) = -1;
            OS_Flags.bEventError = 1;
        }
    }
#endif  // OS_ENABLE_INT_CSEM


#endif  // OS_CSEM_ENABLE














    
    
/****************************************************************************************************
 * 
 * C R I T I C A L   S E C T I O N S
 *
 ****************************************************************************************************/

//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/* Enter critical section                                               */
/************************************************************************/
#if !defined(OS_EnterCriticalSection_DEFINED)
void OS_EnterCriticalSection (void)
{
    _OST_INT_TYPE temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    #ifdef __OSAMCC30__
        OS_Flags.cIPL_Temp = 0;
        *((_OST_INT_TYPE *)&OS_Flags) |= temp;
    #elif defined(__OSAPICC12__)
    #else
        OS_Flags.bGIE_CTemp = 0;
        if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

        #if defined(__OSA18__)
            OS_Flags.bGIEL_CTemp = 0;
            if (temp & 0x40) OS_Flags.bGIEL_CTemp = 1;
        #endif
    #endif
}
#endif

/************************************************************************/
/* Leave critical section                                               */
/************************************************************************/
#if !defined(OS_LeaveCriticalSection_DEFINED)
void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    #ifdef __OSAMCC30__
        temp = *((unsigned int *)&OS_Flags) & 0x00E0;
    #elif defined(__OSAPICC12__)
    #else
        temp = 0;
        if (OS_Flags.bGIE_CTemp) temp |= 0x80;
        #if defined(__OSA18__)
            if (OS_Flags.bGIEL_CTemp) temp |= 0x40;
        #endif
    #endif
    OS_RI(temp);
}
#endif

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TTIMERS

/****************************************************************************************************
 * 
 *  D E L A Y S   I N   T A S K 
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/* Init timer                                                           */
/* (internal system function)                                           */
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#if !defined(_OS_InitDelay_DEFINED)
//------------------------------------------------------------------------------
void _OS_InitDelay (_OST_TTIMER Delay)
{

    _OS_SET_FSR_CUR_TASK();
    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;

    if (Delay)
    {

        Delay ^= -1;
        Delay ++;
        _OS_CurTask->Timer = Delay;
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_InitDelay_DEFINED)
//------------------------------------------------------------------------------

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    








/****************************************************************************************************
 * 
 * 
 *  I N I T I A L I Z E   S Y S T E M   V A R I A B L E S  
 *  
 *
 ****************************************************************************************************/

void OS_Init (void)
{
    *((NEAR _OST_INT_TYPE*)&OS_Flags) = 0;
    OS_Init_ProcSpec(); // Specific controller type's init operations

    #if !defined(OS_DISABLE_PRIORITY)
        _OS_LastTask = (OS_TASKS_BANK OST_TASK_POINTER) &OS_TaskVars[OS_TASKS - 1];
    #endif
    
    //------------------------------------------------------------------------------
    // Zero all old type static timers
    #if OS_TIMERS > 11*8 || ((OS_TIMERS > 0) && defined(__OSAMCC30__))
        _OS_temp = sizeof(OS_Timeouts);
        do {
            OS_Timeouts[_OS_temp-1] = 0;
        } while (--_OS_temp);
    #else
        #if OS_TIMERS > 0
            OS_Timeouts[0] = 0;
        #endif

        #if OS_TIMERS > 1*8
            OS_Timeouts[1] = 0;
        #endif

        #if OS_TIMERS > 2*8
            OS_Timeouts[2] = 0;
        #endif

        #if OS_TIMERS > 3*8
            OS_Timeouts[3] = 0;
        #endif

        #if OS_TIMERS > 4*8
            OS_Timeouts[4] = 0;
        #endif

        #if OS_TIMERS > 5*8
            OS_Timeouts[5] = 0;
        #endif

        #if OS_TIMERS > 6*8
            OS_Timeouts[6] = 0;
        #endif

        #if OS_TIMERS > 7*8
            OS_Timeouts[7] = 0;
        #endif

        #if OS_TIMERS > 8*8
            OS_Timeouts[8] = 0;
        #endif

        #if OS_TIMERS > 9*8
            OS_Timeouts[9] = 0;
        #endif

        #if OS_TIMERS > 10*8
            OS_Timeouts[10] = 0;
        #endif

    #endif
    
    
    #if defined(OS_ENABLE_DTIMERS)
        // Clear list of dynamic timers
        *((OS_BANK char*)&_OS_DTimers.Flags) = 0;
        _OS_DTimers.Flags.bActive = 1;
    #endif

    //------------------------------------------------------------------------------
    // Zero all binary semaphores
    #if OS_BSEMS > 11*8 || ((OS_BSEMS > 0) && defined(__OSAMCC30__))
        _OS_temp = sizeof(OS_BSems) / sizeof(_OST_INT_TYPE);
        do {
            OS_BSems[_OS_temp-1] = 0;
        } while (--_OS_temp);
    #else
        #if OS_BSEMS > 0
            OS_BSems[0] = 0;
        #endif

        #if OS_BSEMS > 1*8
            OS_BSems[1] = 0;
        #endif

        #if OS_BSEMS > 2*8
            OS_BSems[2] = 0;
        #endif

        #if OS_BSEMS > 3*8
            OS_BSems[3] = 0;
        #endif

        #if OS_BSEMS > 4*8
            OS_BSems[4] = 0;
        #endif

        #if OS_BSEMS > 5*8
            OS_BSems[5] = 0;
        #endif

        #if OS_BSEMS > 6*8
            OS_BSems[6] = 0;
        #endif

        #if OS_BSEMS > 7*8
            OS_BSems[7] = 0;
        #endif

        #if OS_BSEMS > 8*8
            OS_BSems[8] = 0;
        #endif

        #if OS_BSEMS > 9*8
            OS_BSems[9] = 0;
        #endif

        #if OS_BSEMS > 10*8
            OS_BSems[10] = 0;
        #endif
    #endif

   
    //------------------------------------------------------------------------------
    // Zero all task descriptors


    #if OS_TASKS > 10
        _OS_CurTask = (OST_TASK_POINTER) OS_TaskVars;
        _OS_temp = OS_TASKS;
        do {
            _OS_CurTask->State.bEnable = 0;
            _OS_CurTask ++;
        } while (--_OS_temp);
    #else

        #ifdef OS_DISABLE_PRIORITY
            _OS_CurTask = (OST_TASK_POINTER)&OS_TaskVars[OS_TASKS-1];
        #endif

        OS_TaskVars[0].State.bEnable = 0;

        #if OS_TASKS > 1
           OS_TaskVars[1].State.bEnable = 0;
        #endif

        #if OS_TASKS > 2
           OS_TaskVars[2].State.bEnable = 0;
        #endif

        #if OS_TASKS > 3
           OS_TaskVars[3].State.bEnable = 0;
        #endif

        #if OS_TASKS > 4
           OS_TaskVars[4].State.bEnable = 0;
        #endif

        #if OS_TASKS > 5
           OS_TaskVars[5].State.bEnable = 0;
        #endif

        #if OS_TASKS > 6
           OS_TaskVars[6].State.bEnable = 0;
        #endif

        #if OS_TASKS > 7
           OS_TaskVars[7].State.bEnable = 0;
        #endif

        #if OS_TASKS > 8
           OS_TaskVars[8].State.bEnable = 0;
        #endif

        #if OS_TASKS > 9
           OS_TaskVars[9].State.bEnable = 0;
        #endif



    #endif

}   













    
    
    
    
    
/****************************************************************************************************
 * 
 * 
 *  T A S K   D E S C R I P T O R S   W O R K
 *  
 *
 ****************************************************************************************************/
    



/************************************************************************/
/*                                                                      */
/* Create task in free descriptor                                       */
/* On return:                                                           */
/*      FSR - pointer to task descriptor                                */
/*      CARRY - =1 - OK,                                                */
/*              =0 - no free descriptor. Task was not created           */
/*                   (need increase OS_TASKS)                           */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

#if !defined(_OS_CreateTask_DEFINED)
bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;

    #if defined(OS_DISABLE_PRIORITY)
    priority = 0;   // To increase scheduler speed
    #endif

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            

            Task->pTaskPointer = TaskAddr;
            #ifdef OS_ENABLE_TTIMERS
                Task->Timer = 0;
            #endif
            #ifdef __OSA18__
                Task->cTempFSR1 = 0;
            #endif
            *((OS_TASKS_BANK char*)&Task->State) = priority;
            // Now FSR points to created task descriptor
            _fsr = (_FSR_TYPE)Task;
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    
    // There is no free descriptor. Task was not created.
    OS_Flags.bError = 1;
    return 0;
}
#endif  // !defined(_OS_CreateTask_DEFINED)


























/****************************************************************************************************
 * 
 * 
 * S Y S T E M   T I M E R   W O R K  
 *  
 * Should be called from periodical place in program
 *
 ****************************************************************************************************/


#ifdef OS_ENABLE_OS_TIMER
#ifndef OS_USE_INLINE_TIMER
void OS_Timer (void)
{                            
    __OS_TimerInline(0);
}
#endif
#endif











/******************************************************************************************
 *
 *  W O R K   W I T H   D Y N A M I C   T I M E R S
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_DTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
#if !defined(_OS_CreateDTimer_DEFINED)
void _OS_CreateDTimer (OST_DTIMER *dtimer)
{
    _OS_temp = OS_DI();
    
    dtimer->Next = _OS_DTimers.Next;
    dtimer->Flags = _OS_DTimers.Flags;
    dtimer->Timer = 0;

    _OS_DTimers.Next = (OST_DTIMER*)dtimer;
    _OS_DTimers.Flags.bNextEnable = 1;
    
    #if !defined(__OSAPICC12__)
    OS_RI(_OS_temp);
    #endif
}
#endif  // !defined(_OS_CreateDTimer_DEFINED)





/************************************************************************/
/*                                                                      */
/************************************************************************/
#if !defined(_OS_DeleteDTimer_DEFINED)
void _OS_DeleteDTimer (OST_DTIMER *dtimer)
{

    OST_DTIMER *ptcb;
    
    // Search current timer in list
    ptcb = (OST_DTIMER*)&_OS_DTimers;
    while (ptcb->Flags.bNextEnable) {
        if (ptcb->Next == dtimer) {   // Current timer is found
            ptcb->Next = dtimer->Next;
            if (!dtimer->Flags.bNextEnable) ptcb->Flags.bNextEnable = 0;
            dtimer->Flags.bActive = 0;
            return;
        }
        ptcb = ptcb->Next;
    }
}
#endif  // !defined(_OS_DeleteDTimer_DEFINED)
        



#endif  //  OS_ENABLE_DTIMERS


























/****************************************************************************************************
 * 
 * C H E C K   E V E N T   A N D   S E T / C L E A R   R E A D Y   F L A G 
 *
 * (internal system function) 
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#if !defined(_OS_CheckEvent_DEFINED)
//------------------------------------------------------------------------------
#if     defined(__OSA16__)  || defined(__OSA12__)
    bit _OS_CheckEvent (char bEvent)
    #define _OS_CheckEvent_EXIT_GOOD    return 1
    #define _OS_CheckEvent_EXIT_BAD     return 0
#else 
    void _OS_CheckEvent (_OST_INT_TYPE bEvent)
    #define _OS_CheckEvent_EXIT_GOOD    return
    #define _OS_CheckEvent_EXIT_BAD     _PIC18_POP()
#endif
    {

        OS_Flags.bTimeout = 0;
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        _SET_TASK_IRP();
        if (bEvent) {
            if (_OS_bTaskReady) {
                #ifdef OS_ENABLE_TTIMERS
                    _OS_bTaskDelay = 0;
                #endif
                _OS_CheckEvent_EXIT_GOOD;
            }
            _OS_bTaskReady = 1;
        } else {
            _OS_bTaskReady = 0;
        }
        #ifdef OS_ENABLE_TTIMERS
            if (_OS_bTaskTimeout && _OS_bTaskCanContinue) {
                OS_Flags.bTimeout = 1;
                _OS_CheckEvent_EXIT_GOOD;
            }
        #endif
        _OS_CheckEvent_EXIT_BAD;
    
    }

//------------------------------------------------------------------------------
#endif  // !defined(_OS_CheckEvent_DEFINED)
//------------------------------------------------------------------------------
    
    

        


    







/****************************************************************************************************
 * 
 * 
 *  S I M P L E    M E S S A G E S   C H E C K
 *  
 *
 ****************************************************************************************************/

#if defined(OS_ENABLE_INT_SMSG) && (OS_SMSG_SIZE > 1)

    bit _OS_CheckSMsg(OST_SMSG* smsg)
    {
        _OS_temp = OS_DI();
        if (*smsg) _OS_temp |= 1;
        OS_RI(_OS_temp);
        return _OS_temp & 1;
    }

#endif







/****************************************************************************************************
 * 
 * 
 *  M E S S A G E   Q U E U E S 
 *  
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------

#if defined(OS_ENABLE_QSMSG) && !defined(OS_QMSG_QSMSG_IDENTICAL)


/************************************************************************/
/*                                                                      */
/* Add message into queue of simple messages                            */
/* Return 1 if first message in queue was pushed off                    */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#if !defined(_OS_SendQSMsg_DEFINED)
//------------------------------------------------------------------------------
void _OS_SendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    __OS_QMSG_DI();
    q = pQSMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               // Delete first message if there is no free room to add new message.
    {                                                       // OS_SendQSMsg before adding new message checks for free room.
        pQSMsg->pSMsg[q.cBegin] = SMsg;                     // Thus messages will not deleted accidentally.
        q.cBegin++;
        if (q.cBegin == q.cSize) q.cBegin = 0;

        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQSMsg->pSMsg[temp] = SMsg;
    q.cFilled++;
EXIT:
    pQSMsg->Q = q;
    __OS_QMSG_RI();
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_SendQSMsg_DEFINED)
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#if defined(OS_ENABLE_INT_QMSG) && !defined(_OS_IntSendQSMsg_DEFINED)
//------------------------------------------------------------------------------
void _OS_IntSendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    q = pQSMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               // Delete first message if there is no free room to add new message.
    {                                                       // OS_SendQSMsg before adding new message checks for free room.
        pQSMsg->pSMsg[q.cBegin] = SMsg;                     // Thus messages will not deleted accidentally.
        q.cBegin++;
        if (q.cBegin == q.cSize) q.cBegin = 0;

        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQSMsg->pSMsg[temp] = SMsg;
    q.cFilled++;
EXIT:
    pQSMsg->Q = q;
}
//------------------------------------------------------------------------------
#endif  // (OS_ENABLE_INT_QMSG) && !defined(_OS_IntSendQSMsg_DEFINED)
//------------------------------------------------------------------------------


/************************************************************************/
/*                                                                      */
/* Get first message from queue                                         */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#if !defined(_OS_GetQSMsg_DEFINED)
//------------------------------------------------------------------------------
OST_SMSG _OS_GetQSMsg (OST_QSMSG *pQSMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    q = pQSMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQSMsg->Q = q;
    return pQSMsg->pSMsg[temp];
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_GetQSMsg_DEFINED)
//------------------------------------------------------------------------------
#endif




//------------------------------------------------------------------------------
#if defined(OS_ENABLE_QMSG)

/************************************************************************/
/*                                                                      */
/* Add message into queue of pointers to message                        */
/* Return 1 if first message in queue was pushed off                    */
/*                                                                      */
/************************************************************************/


//------------------------------------------------------------------------------
#if !defined(_OS_SendQMsg_DEFINED)
//------------------------------------------------------------------------------
void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{

    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    __OS_QMSG_DI();
    q = pQMsg->Q;
    OS_Flags.bEventError = 0;

    if (q.cSize == q.cFilled)                               // Delete first message if there is no free room to add new message.
    {                                                       // OS_SendQSMsg before adding new message checks for free room.
        pQMsg->pMsg[q.cBegin] = Msg;                        // Thus messages will not deleted accidentally.
        q.cBegin++;
        if (q.cBegin == q.cSize) q.cBegin = 0;

        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQMsg->pMsg[temp] = Msg;
    q.cFilled++;
EXIT:
    pQMsg->Q = q;
    __OS_QMSG_RI();
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_SendQMsg_DEFINED)
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
#if defined(OS_ENABLE_INT_QMSG) && !defined(_OS_IntSendQMsg_DEFINED)
//------------------------------------------------------------------------------
void _OS_IntSendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{

    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    q = pQMsg->Q;
    OS_Flags.bEventError = 0;

    if (q.cSize == q.cFilled)                               // Delete first message if there is no free room to add new message.
    {                                                       // OS_SendQSMsg before adding new message checks for free room.
        pQMsg->pMsg[q.cBegin] = Msg;                        // Thus messages will not deleted accidentally.
        q.cBegin++;
        if (q.cBegin == q.cSize) q.cBegin = 0;

        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQMsg->pMsg[temp] = Msg;
    q.cFilled++;
EXIT:
    pQMsg->Q = q;
}
//------------------------------------------------------------------------------
#endif  // (OS_ENABLE_INT_QMSG) && !defined(_OS_IntSendQMsg_DEFINED)
//------------------------------------------------------------------------------



/************************************************************************/
/*                                                                      */
/* Get first message from queue                                         */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#if !defined(_OS_GetQMsg_DEFINED)
//------------------------------------------------------------------------------
OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg)
{
    OST_QUEUE_CONTROL   q;
    _OST_INT_TYPE temp;

    q = pQMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQMsg->Q = q;
    return pQMsg->pMsg[temp];
}
//------------------------------------------------------------------------------
#endif  // !defined(_OS_GetQMsg_DEFINED)
//------------------------------------------------------------------------------
#endif
//------------------------------------------------------------------------------




