NEAR OST_TASK_STATE     OS_state    __osa30_near;

#define OS_Init_ProcSpec()      // Empty macro for PIC12


//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TTIMERS

/****************************************************************************************************
 * 
 *  D E L A Y S   W O R K 
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/* Init task timer for counting                                         */
/* (internal system function)                                           */
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_InitDelay_DEFINED
//------------------------------------------------------------------------------
void _OS_InitDelay (_OST_TTIMER Delay)
{

    _OS_bTaskCanContinue = 0;
    _OS_bTaskDelay = 0;         // Clear bDelay to prevent timer changing in interrupt

    if (Delay)
    {

        Delay ^= -1;
        Delay ++;
        
        #if     OS_TTIMER_SIZE == 1
            asm("   movlw   2   ");
            asm("   addwf   __OS_CurTask, w ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr    ");
            asm("   movf    ?a__OS_InitDelay, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            _OS_SET_TASK_IRP_0();
        #elif   OS_TTIMER_SIZE == 2
            asm("   movlw   2   ");
            asm("   addwf   __OS_CurTask, w ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr    ");
            asm("   movf    ?__OS_InitDelay + 1, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 2, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();

        #elif   OS_TTIMER_SIZE == 4
            asm("   movlw   2   ");
            asm("   addwf   __OS_CurTask, w ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr    ");
            asm("   movf    ?__OS_InitDelay + 1, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 2, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 3, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
            asm("   incf    __fsr ");
            asm("   movf    ?__OS_InitDelay + 4, w");
            _OS_SET_TASK_IRP();
            asm("   movwf   __indf");
            
            _OS_SET_TASK_IRP_0();
        #endif
        
        _OS_SET_FSR_CUR_TASK();
        _OS_bTaskDelay = 1;
        _OS_bTaskReady = 1;

    }
}

//______________________________________________________________________________
//******************************************************************************

#endif  // #ifdef OS_TIMER














/****************************************************************************************************
 * 
 * 
 *  T A S K   W O R K   F U N C T I O N S
 *  
 *
 ****************************************************************************************************/
    



/************************************************************************/
/*                                                                      */
/* Create task in any free descriptor                                   */
/* On return:                                                           */
/*      =1 - OK,                                                        */
/*      =0 - there is no free descriptor                                */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#define _OS_CreateTask_DEFINED
//------------------------------------------------------------------------------
bit _OS_CreateTask(_OST_INT_TYPE priority, OST_CODE_POINTER TaskAddr)
{
    OST_TASK_POINTER Task;
    
    OS_Flags.bError = 0;


    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;
            ((OST_TASK_STATE*)&priority)->bReady = 1;
            
            asm("   incf    __OS_CreateTask$Task, w     ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr                        ");
            asm("   movf    __OS_CreateTask$TaskAddr, w      ");
            _OS_SET_TASK_IRP();
            asm("   movwf    __indf ");
            asm("   decf    __fsr   ");
            _OS_SET_TASK_IRP_0();
            asm("   movf    __OS_CreateTask$priority, w      ");   // priority
            _OS_SET_TASK_IRP();
            asm("   movwf    __indf ");
            _OS_SET_TASK_IRP_0();
            if (Task == _OS_CurTask) OS_state = *((OST_TASK_STATE*)&priority);
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);

    // No free descriptor
    OS_Flags.bError = 1;
    return 0;
}














/******************************************************************************************
 *
 *  P T I M E R S   W O R K  
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_DTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_CreateDTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_CreateDTimer (OST_DTIMER *dtimer)
{
    //------------------------------------------------------------------------------
    // dtimer->Flags = _OS_DTimers.Flags;
        #if _BANKBITS_ == 2
        asm("   bcf     __status, 0             ");
        asm("   btfsc   __OS_CreateDTimer$dtimer, 6  ");
        asm("   bsf     __status, 0             ");
        #endif
        asm("   movf    __OS_CreateDTimer$dtimer, w  ");
        _OS_PIC12_AND_1F();
        asm("   movwf   __fsr                   ");
        //-------
        _OS_SET_OS_IRP();
        asm("   movf    __OS_DTimers & 0x1F, w  ");
        _OS_SET_OS_IRP_0();
        //-------
        #if _BANKBITS_ >= 1
        asm("   btfsc   __OS_CreateDTimer$dtimer, 5 ");
        asm("   bsf     __fsr, 5            ");
        #endif
        #if _BANKBITS_ == 2
        asm("   btfsc   __status, 0 ");
        asm("   bsf     __fsr, 6            ");
        #endif
        asm("   movwf   __indf              ");
        _fsr = 0;

    //------------------------------------------------------------------------------
    // dtimer->Next = _OS_DTimers.Next;
        
        /* Now CARRY = __OS_CreateDTimer$dtimer.6 */

        asm("   movf    __OS_CreateDTimer$dtimer, w      ");
        _OS_PIC12_AND_1F();
        asm("   movwf   __fsr                       ");
        asm("   incf    __fsr, f                    ");
        //-------
        _OS_SET_OS_IRP();
        asm("   movf    (__OS_DTimers + 1) & 0x1F, w");
        _OS_SET_OS_IRP_0();
        //-------
    #if _BANKBITS_ >= 1
        asm("   btfsc   __OS_CreateDTimer$dtimer, 5      ");
        asm("   bsf     __fsr, 5                    ");
    #endif
    #if _BANKBITS_ == 2
        asm("   btfsc   __status, 0 ");
        asm("   bsf     __fsr, 6                    ");
    #endif
        asm("   movwf   __indf                      ");
        _fsr = 0;
        
    //------------------------------------------------------------------------------
    dtimer->Timer = 0;

            
    _OS_DTimers.Next = (OST_DTIMER*)dtimer;
    _OS_DTimers.Flags.bNextEnable = 1;
    
}






/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
#define _OS_DeleteDTimer_DEFINED
//------------------------------------------------------------------------------
void _OS_DeleteDTimer (OST_DTIMER *dtimer)
{

    OST_DTIMER *ptcb;
    
    ptcb = (OST_DTIMER*)&_OS_DTimers;
    while (ptcb->Flags.bNextEnable) {
        if (ptcb->Next == dtimer) {   
            _OS_temp = (_OST_INT_TYPE)dtimer->Next;
            //------------------------------------------------------------------------------
            //ptcb->Next = _OS_temp;
            #if _BANKBITS_ == 2
                asm("   bcf     __status, 0                 ");
                asm("   btfsc   __OS_DeleteDTimer$ptcb, 6   ");
                asm("   bsf     __status, 0                 ");
            #endif
            asm("   movf    __OS_DeleteDTimer$ptcb, w       ");
            _OS_PIC12_AND_1F();
            asm("   movwf   __fsr                   ");
            asm("   incf    __fsr, f                ");
            //-------
            asm("   movf    __OS_temp, w  ");
            //-------
            #if _BANKBITS_ >= 1
                asm("   btfsc   __OS_DeleteDTimer$ptcb, 5   ");
                asm("   bsf     __fsr, 5                    ");
            #endif
            #if _BANKBITS_ == 2
                asm("   btfsc   __status, 0 ");
                asm("   bsf     __fsr, 6            ");
            #endif
            asm("   movwf   __indf              ");
            _fsr = 0;
            
            if (!dtimer->Flags.bNextEnable) ptcb->Flags.bNextEnable = 0;
            dtimer->Flags.bActive = 0;
            return;
        }
        ptcb = ptcb->Next;
    }
}



#endif  //  OS_ENABLE_DTIMERS


























/****************************************************************************************************
 * 
 * C H E C K   E V E N T   A N D   S E T / C L E A R   R E A D Y   F L A G 
 *
 * (internal system function) 
 *
 ****************************************************************************************************/



//------------------------------------------------------------------------------
#define _OS_CheckEvent_DEFINED
//------------------------------------------------------------------------------
bit _OS_CheckEvent (char bEvent)
{
    OS_Flags.bTimeout = 0;
    if (bEvent) {
        if (_OS_bTaskReady) {
            #ifdef OS_ENABLE_TTIMERS
                _OS_bTaskDelay = 0;
            #endif
            return 1;
        }
        _OS_bTaskReady = 1;
    } else _OS_bTaskReady = 0;
    #ifdef OS_ENABLE_TTIMERS
        if (_OS_bTaskTimeout && _OS_bTaskCanContinue) {
            OS_Flags.bTimeout = 1;
            return 1;
        }
    #endif
    return 0;
}


    

        

        











/****************************************************************************************************
 * 
 * 
 *  Q U E U E   O F   M E S S A G E S   F U N C T I O N S 
 *  
 *
 ****************************************************************************************************/


//------------------------------------------------------------------------------
#if defined(OS_ENABLE_QMSG)

/************************************************************************/
/*                                                                      */
/* Add message into queue                                               */
/* Returns 1 if first message was pushed out                            */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_SendQMsg_DEFINED
#define _OS_SendQSMsg_DEFINED
//------------------------------------------------------------------------------

void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{
    OS_Flags.bEventError = 0;

    // if pQMsg->Q.cSize == pQMsg->Q.cFilled
    _fsr = (_FSR_TYPE) pQMsg;
    asm("   movf    __indf, w               ");     // w = pQMsg->Q.cSize
    asm("   incf    __fsr, f                ");     // fsr -> pQMsg->Q.cFilled
    asm("   xorwf   __indf, w               ");     // Compare cSize  cFilled
    
    if (_status & 0x04) {   // Check ZERO flag

        _fsr = 0;
        OS_Flags.bEventError = 1;

        // pQMsg->pMsg[pQMsg->Q.cBegin] = Msg;
        _fsr = (_FSR_TYPE) pQMsg;
        asm("   incf    __fsr, f        ");
        asm("   incf    __fsr, f        ");
        asm("   movf    __indf, w       ");     // w = pQMsg->Q.cBegin
    PUT_MESSAGE:
        asm("   incf    __fsr, f        ");
        asm("   addwf   __indf, w       ");
        asm("   movwf   __fsr           ");     // fsr -> pQMsg->pMsg[pQMsg->Q.cBegin]
        


        #ifdef _16F59
            asm("   bcf     __status, 5     "); // Here we use ROM page bit to store FSR.7
            asm("   btfsc   __fsr, 7        ");
            asm("   bsf     __status, 5     ");
            asm("   bcf     __fsr, 7     ");
        #endif

        #if _BANKBITS_ == 2
            asm("   bcf     __status, 1     ");
            asm("   btfsc   __fsr, 6        ");
            asm("   bsf     __status, 1     ");
            asm("   bcf     __fsr, 6     ");
        #endif
        #if _BANKBITS_ >= 1
            asm("   bcf     __status, 0     ");
            asm("   btfsc   __fsr, 5        ");
            asm("   bsf     __status, 0     ");
            asm("   bcf     __fsr, 5     ");
        #endif

        asm("   movf    __OS_SendQMsg$Msg, w    ");

        #ifdef _16F59
            asm("   btfsc   __status, 5     "); // Here we use ROM page bit to store FSR.7
            asm("   bsf     __fsr, 7        ");
            asm("   dw  0x4A3   | (($ & 0x200) >>1)");
        #endif
        #if _BANKBITS_ == 2
            asm("   btfsc   __status, 1     ");
            asm("   bsf     __fsr, 6        ");
        #endif
        #if _BANKBITS_ >= 1
            asm("   btfsc   __status, 0     ");
            asm("   bsf     __fsr, 5        ");
        #endif
        asm("   movwf   __indf              ");

        
        // Set status, c = bEventError.
        // This will help to select register to increaze and compare to cSize
        // If there will be an error then cBegin++, else cFilled++
        
        _fsr = 0;
        _status &= 0xFE;
        if (OS_Flags.bEventError) _status |= 0x01;

        // pQMsg->Q.cBegin++ (or pQMsg->Q.cFileld++) and compare it to cSize
        _fsr = (_FSR_TYPE) pQMsg;
        asm("   movf    __indf, w               ");
        asm("   btfsc   __status, 0             ");     // Skip ink FSR if there was not error
        asm("   incf    __fsr, f                ");
        asm("   incf    __fsr, f                ");     // fsr -> pQMsg->Q.cBegin
        asm("   incf    __indf, f               ");     // cBegin++ ( cFilled++)
        if (_status & 1) {        
            asm("   xorwf   __indf, w           ");     // Compare cBegin (or cFilled) to cSize
            asm("   btfsc   __status, 2         ");
            asm("   clrf    __indf              ");     // cBegin (or cFilled) = 0
        }    
        asm("   clrf    __fsr                   ");
        return;
    }

    //temp = q.cBegin + q.cFilled;
    //if (temp >= q.cSize) temp -= q.cSize;
    asm("   incf    __fsr, f                ");
    asm("   movf    __indf, w               ");     // w = cBegin
    asm("   decf    __fsr, f                ");
    asm("   addwf   __indf, w               ");     // w += cFilled
    asm("   decf    __fsr, f                ");
    asm("   subwf   __indf, w               ");     // w = cSize - (cFileld + cBegin)
    asm("   btfss   __status, 0             ");     // > 0
    asm("   addwf   __indf, w               ");     // Correcting pointer
    asm("   subwf   __indf, w               ");     // w = cSize - (cFileld + cBegin)
    asm("   incf    __fsr, f                ");
    asm("   incf    __fsr, f                ");
    goto    PUT_MESSAGE;

}



/************************************************************************/
/*                                                                      */
/* Get one message from queue                                           */
/*                                                                      */
/************************************************************************/

//------------------------------------------------------------------------------
#define _OS_GetQMsg_DEFINED
#define _OS_GetQSMsg_DEFINED
//------------------------------------------------------------------------------

OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg)
{
    char temp;

    _fsr = (_FSR_TYPE)pQMsg;
    _fsr++;
    _fsr++;
    asm("   movf    __indf, w           "); // w = cBegin
    asm("   incf    __fsr, f            "); // fsr -> pMsg
    asm("   addwf   __indf, w           "); 
    asm("   movwf   __fsr               "); // fsr -> pMsg[cBegin]
    asm("   movf    __indf, w           "); // w = pMsg[cBegin]
    asm("   clrf    __fsr               ");
    asm("   movwf   __OS_GetQMsg$temp   ");

    // Here FSR bits 5 and 6 are cleared (due to work with "temp")
    _fsr = (_FSR_TYPE)pQMsg;
    asm("   movf    __indf, w           ");
    asm("   incf    __fsr, f            ");
    asm("   incf    __fsr, f            ");
    asm("   incf    __indf, f           "); // cBegin++
    asm("   subwf   __indf, w           ");
    asm("   btfsc   __status, 0         "); // if (cBegin >= cSize) cBegin = 0;
    asm("   clrf    __indf              ");
    asm("   decf    __fsr, f            ");
    asm("   decf    __indf, f           "); // cFilled--

    _fsr = 0;
    return (OST_MSG)temp;
}
#endif
//------------------------------------------------------------------------------


















